std::list< _Tp, _Alloc >(3)

NAME
std::list< _Tp, _Alloc > -

SYNOPSIS

Inherits std::_List_base< _Tp, _Alloc >.

  Public Types
typedef _Alloc allocator_type
typedef _List_const_iterator< _Tp > const_iterator
typedef
_Tp_alloc_type::const_pointer const_pointer"
typedef
_Tp_alloc_type::const_reference const_reference"
typedef std::reverse_iterator
< const_iterator > const_reverse_iterator"
typedef ptrdiff_t difference_type
typedef _List_iterator< _Tp > iterator
typedef _Tp_alloc_type::pointer pointer
typedef _Tp_alloc_type::reference reference
typedef std::reverse_iterator
< iterator > reverse_iterator"
typedef size_t size_type
typedef _Tp value_type

  Public Member Functions
list ()
list (const allocator_type &__a)
list (size_type __n)
list (size_type __n, const value_type &__value, const allocator_type &__a=allocator_type())
list (const list &__x)
list (list &&__x) noexcept
list (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> list (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
void assign (size_type __n, const value_type &__val)
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> void assign (_InputIterator __first, _InputIterator __last)
void assign (initializer_list< value_type > __l)
reference back ()
const_reference back () const
iterator begin () noexcept
const_iterator begin () const noexcept
const_iterator cbegin () const noexcept
const_iterator cend () const noexcept
void clear () noexcept
const_reverse_iterator crbegin () const noexcept
const_reverse_iterator crend () const noexcept
template<typename... _Args> list< _Tp, _Alloc >::iterator emplace (iterator __position, _Args &&...__args)
template<typename... _Args> iterator emplace (iterator __position, _Args &&...__args)
template<typename... _Args> void emplace_back (_Args &&...__args)
template<typename... _Args> void emplace_front (_Args &&...__args)
bool empty () const noexcept
iterator end () noexcept
const_iterator end () const noexcept
iterator erase (iterator __position)
iterator erase (iterator __first, iterator __last)
reference front ()
const_reference front () const
allocator_type get_allocator () const noexcept
iterator insert (iterator __position, const value_type &__x)
iterator insert (iterator __position, value_type &&__x)
void insert (iterator __p, initializer_list< value_type > __l)
void insert (iterator __position, size_type __n, const value_type &__x)
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> void insert (iterator __position, _InputIterator __first, _InputIterator __last)
size_type max_size () const noexcept
void merge (list &&__x)
void merge (list &__x)
template<typename _StrictWeakOrdering > void merge (list &&__x, _StrictWeakOrdering __comp)
template<typename _StrictWeakOrdering > void merge (list &__x, _StrictWeakOrdering __comp)
list & operator= (const list &__x)
list & operator= (list &&__x)
list & operator= (initializer_list< value_type > __l)
void pop_back ()
void pop_front ()
void push_back (const value_type &__x)
void push_back (value_type &&__x)
void push_front (const value_type &__x)
void push_front (value_type &&__x)
reverse_iterator rbegin () noexcept
const_reverse_iterator rbegin () const noexcept
void remove (const _Tp &__value)
template<typename _Predicate > void remove_if (_Predicate)
reverse_iterator rend () noexcept
const_reverse_iterator rend () const noexcept
void resize (size_type __new_size)
void resize (size_type __new_size, const value_type &__x)
void reverse () noexcept
size_type size () const noexcept
void sort ()
template<typename _StrictWeakOrdering > void sort (_StrictWeakOrdering)
void splice (iterator __position, list &&__x)
void splice (iterator __position, list &__x)
void splice (iterator __position, list &&__x, iterator __i)
void splice (iterator __position, list &__x, iterator __i)
void splice (iterator __position, list &&__x, iterator __first, iterator __last)
void splice (iterator __position, list &__x, iterator __first, iterator __last)
void swap (list &__x)
void unique ()
template<typename _BinaryPredicate > void unique (_BinaryPredicate)

  Protected Types
typedef _List_node< _Tp > _Node

  Protected Member Functions
template<typename _Integer > void _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
template<typename _InputIterator > void _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
void _M_check_equal_allocators (list &__x)
void _M_clear ()
template<typename... _Args> _Node * _M_create_node (_Args &&...__args)
void _M_default_append (size_type __n)
void _M_default_initialize (size_type __n)
void _M_erase (iterator __position)
void _M_fill_assign (size_type __n, const value_type &__val)
void _M_fill_initialize (size_type __n, const value_type &__x)
_List_node< _Tp > * _M_get_node ()
_Node_alloc_type & _M_get_Node_allocator () noexcept
const _Node_alloc_type & _M_get_Node_allocator () const noexcept
_Tp_alloc_type _M_get_Tp_allocator () const noexcept
void _M_init ()
template<typename _Integer > void _M_initialize_dispatch (_Integer __n, _Integer __x, __true_type)
template<typename _InputIterator > void _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
template<typename... _Args> void _M_insert (iterator __position, _Args &&...__args)
void _M_put_node (_List_node< _Tp > *__p)
void _M_transfer (iterator __position, iterator __first, iterator __last)

  Protected Attributes
_List_impl _M_impl

Detailed Description

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>>class std::list< _Tp, _Alloc >
A standard container with linear time access to elements, and fixed time insertion/deletion at any point in the sequence.

Template Parameters:
    _Tp Type of element.
    _Alloc Allocator type, defaults to allocator<_Tp>.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements with the exception of at and operator[].

This is a doubly linked list. Traversal up and down the list requires linear time, but adding and removing elements (or nodes) is done in constant time, regardless of where the change takes place. Unlike std::vector and std::deque, random-access iterators are not provided, so subscripting ( [] ) access is not allowed. For algorithms which only need sequential access, this lack makes no difference.

Also unlike the other standard containers, std::list provides specialized algorithms unique to linked lists, such as splicing, sorting, and in-place reversal.

A couple points on memory allocation for list<Tp>:

First, we never actually allocate a Tp, we allocate List_node<Tp>'s and trust [20.1.5]/4 to DTRT. This is to ensure that after elements from list<X,Alloc1> are spliced into list<X,Alloc2>, destroying the memory of the second list is a valid operation, i.e., Alloc1 giveth and Alloc2 taketh away.

Second, a list conceptually represented as

A <---> B <---> C <---> D

 is actually circular; a link exists between A and D. The list class holds (as its only data member) a private list::iterator pointing to D, not to A! To get to the head of the list, we start at the tail and move forward by one. When this member iterator's next/previous pointers refer to itself, the list is empty.

Definition at line 438 of file stl_list.h.

Constructor & Destructor Documentation

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::list< _Tp, _Alloc >::list () [inline]

Default constructor creates no elements.

Definition at line 523 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::list< _Tp, _Alloc >::list (const allocator_type &__a) [inline], [explicit]

Creates a list with no elements.

Parameters:
    __a An allocator object.

Definition at line 531 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::list< _Tp, _Alloc >::list (size_type__n) [inline], [explicit]

Creates a list with default constructed elements.

Parameters:
    __n The number of elements to initially create.

This constructor fills the list with __n default constructed elements.

Definition at line 543 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::list< _Tp, _Alloc >::list (size_type__n, const value_type &__value, const allocator_type &__a = allocator_type()) [inline]

Creates a list with copies of an exemplar element.

Parameters:
    __n The number of elements to initially create.
    __value An element to copy.
    __a An allocator object.

This constructor fills the list with __n copies of __value.

Definition at line 555 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::list< _Tp, _Alloc >::list (const list< _Tp, _Alloc > &__x) [inline]

List copy constructor.

Parameters:
    __x A list of identical element and allocator types.

The newly-created list uses a copy of the allocation object used by __x.

Definition at line 582 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::list< _Tp, _Alloc >::list (list< _Tp, _Alloc > &&__x) [inline], [noexcept]

List move constructor.

Parameters:
    __x A list of identical element and allocator types.

The newly-created list contains the exact contents of __x. The contents of __x are a valid, but unspecified list.

Definition at line 594 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::list< _Tp, _Alloc >::list (initializer_list< value_type >__l, const allocator_type &__a = allocator_type()) [inline]

Builds a list from an initializer_list.

Parameters:
    __l An initializer_list of value_type.
    __a An allocator object.

Create a list consisting of copies of the elements in the initializer_list __l. This is linear in __l.size().

Definition at line 605 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> std::list< _Tp, _Alloc >::list (_InputIterator__first, _InputIterator__last, const allocator_type &__a = allocator_type()) [inline]

Builds a list from a range.

Parameters:
    __first An input iterator.
    __last An input iterator.
    __a An allocator object.

Create a list consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 624 of file stl_list.h.

Member Function Documentation

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename... _Args> _Node* std::list< _Tp, _Alloc >::_M_create_node (_Args &&...__args) [inline], [protected]

Parameters:
    __args An instance of user data.

Allocates space for a new node and constructs a copy of __args in it.

Definition at line 500 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::assign (size_type__n, const value_type &__val) [inline]

Assigns a given value to a list.

Parameters:
    __n Number of elements to be assigned.
    __val Value to be assigned.

This function fills a list with __n copies of the given value. Note that the assignment completely changes the list and that the resulting list's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 702 of file stl_list.h.

Referenced by std::list< __inp, __rebind_inp >::assign(), and std::list< __inp, __rebind_inp >::operator=().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> void std::list< _Tp, _Alloc >::assign (_InputIterator__first, _InputIterator__last) [inline]

Assigns a range to a list.

Parameters:
    __first An input iterator.
    __last An input iterator.

This function fills a list with copies of the elements in the range [__first,__last).

Note that the assignment completely changes the list and that the resulting list's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 721 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::assign (initializer_list< value_type >__l) [inline]

Assigns an initializer_list to a list.

Parameters:
    __l An initializer_list of value_type.

Replace the contents of the list with copies of the elements in the initializer_list __l. This is linear in __l.size().

Definition at line 743 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reference std::list< _Tp, _Alloc >::back () [inline]
Returns a read/write reference to the data at the last element of the list.

Definition at line 943 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reference std::list< _Tp, _Alloc >::back () const [inline]
Returns a read-only (constant) reference to the data at the last element of the list.

Definition at line 955 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::list< _Tp, _Alloc >::begin () [inline], [noexcept]
Returns a read/write iterator that points to the first element in the list. Iteration is done in ordinary element order.

Definition at line 758 of file stl_list.h.

Referenced by std::list< __inp, __rebind_inp >::crend(), std::list< __inp, __rebind_inp >::front(), std::list< __inp, __rebind_inp >::list(), std::list< _Tp, _Alloc >::merge(), std::list< _Tp, _Alloc >::operator=(), std::operator==(), std::list< __inp, __rebind_inp >::pop_front(), std::list< __inp, __rebind_inp >::push_front(), std::list< __inp, __rebind_inp >::rend(), std::list< __inp, __rebind_inp >::size(), std::list< _Tp, _Alloc >::sort(), and std::list< __inp, __rebind_inp >::splice().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_iterator std::list< _Tp, _Alloc >::begin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the list. Iteration is done in ordinary element order.

Definition at line 767 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_iterator std::list< _Tp, _Alloc >::cbegin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the list. Iteration is done in ordinary element order.

Definition at line 831 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_iterator std::list< _Tp, _Alloc >::cend () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the list. Iteration is done in ordinary element order.

Definition at line 840 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::clear () [inline], [noexcept]
Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1228 of file stl_list.h.

Referenced by std::list< __inp, __rebind_inp >::operator=().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reverse_iterator std::list< _Tp, _Alloc >::crbegin () const [inline], [noexcept]
Returns a read-only (constant) reverse iterator that points to the last element in the list. Iteration is done in reverse element order.

Definition at line 849 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reverse_iterator std::list< _Tp, _Alloc >::crend () const [inline], [noexcept]
Returns a read-only (constant) reverse iterator that points to one before the first element in the list. Iteration is done in reverse element order.

Definition at line 858 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename... _Args> iterator std::list< _Tp, _Alloc >::emplace (iterator__position, _Args &&...__args)

Constructs object in list before specified iterator.

Parameters:
    __position A const_iterator into the list.
    __args Arguments.

Returns:
    An iterator that points to the inserted data.

This function will insert an object of type T constructed with T(std::forward<Args>(args)...) before the specified location. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Referenced by std::list< __inp, __rebind_inp >::insert().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> bool std::list< _Tp, _Alloc >::empty () const [inline], [noexcept]
Returns true if the list is empty. (Thus begin() would equal end().)

Definition at line 868 of file stl_list.h.

Referenced by std::list< _Tp, _Alloc >::sort(), and std::list< __inp, __rebind_inp >::splice().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::list< _Tp, _Alloc >::end () [inline], [noexcept]
Returns a read/write iterator that points one past the last element in the list. Iteration is done in ordinary element order.

Definition at line 776 of file stl_list.h.

Referenced by std::list< __inp, __rebind_inp >::back(), std::list< __inp, __rebind_inp >::crbegin(), std::list< __inp, __rebind_inp >::list(), std::list< _Tp, _Alloc >::merge(), std::list< _Tp, _Alloc >::operator=(), std::operator==(), std::list< __inp, __rebind_inp >::push_back(), std::list< __inp, __rebind_inp >::rbegin(), std::list< __inp, __rebind_inp >::size(), and std::list< __inp, __rebind_inp >::splice().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_iterator std::list< _Tp, _Alloc >::end () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the list. Iteration is done in ordinary element order.

Definition at line 785 of file stl_list.h.

  template<typename _Tp , typename _Alloc > list< _Tp, _Alloc >::iterator list::erase (iterator__position)

Remove element at given position.

Parameters:
    __position Iterator pointing to element to be erased.

Returns:
    An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the list by one.

Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed. The user is also cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 109 of file list.tcc.

Referenced by std::list< __inp, __rebind_inp >::erase().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::list< _Tp, _Alloc >::erase (iterator__first, iterator__last) [inline]

Remove a range of elements.

Parameters:
    __first Iterator pointing to the first element to be erased.
    __last Iterator pointing to one past the last element to be erased.

Returns:
    An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the list accordingly.

This operation is linear time in the size of the range and only invalidates iterators/references to the element being removed. The user is also cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1193 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reference std::list< _Tp, _Alloc >::front () [inline]
Returns a read/write reference to the data at the first element of the list.

Definition at line 927 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reference std::list< _Tp, _Alloc >::front () const [inline]
Returns a read-only (constant) reference to the data at the first element of the list.

Definition at line 935 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> allocator_type std::list< _Tp, _Alloc >::get_allocator () const [inline], [noexcept]

Get a copy of the memory allocation object.

Definition at line 749 of file stl_list.h.

Referenced by std::list< __inp, __rebind_inp >::insert().

  template<typename _Tp , typename _Alloc > list< _Tp, _Alloc >::iterator list::insert (iterator__position, const value_type &__x)

Inserts given value into list before specified iterator.

Parameters:
    __position An iterator into the list.
    __x Data to be inserted.

Returns:
    An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 99 of file list.tcc.

Referenced by std::list< __inp, __rebind_inp >::insert().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::list< _Tp, _Alloc >::insert (iterator__position, value_type &&__x) [inline]

Inserts given rvalue into list before specified iterator.

Parameters:
    __position An iterator into the list.
    __x Data to be inserted.

Returns:
    An iterator that points to the inserted data.

This function will insert a copy of the given rvalue before the specified location. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 1089 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::insert (iterator__p, initializer_list< value_type >__l) [inline]

Inserts the contents of an initializer_list into list before specified iterator.

Parameters:
    __p An iterator into the list.
    __l An initializer_list of value_type.

This function will insert copies of the data in the initializer_list l into the list before the location specified by p.

This operation is linear in the number of elements inserted and does not invalidate iterators and references.

Definition at line 1106 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::insert (iterator__position, size_type__n, const value_type &__x) [inline]

Inserts a number of copies of given data into the list.

Parameters:
    __position An iterator into the list.
    __n Number of elements to be inserted.
    __x Data to be inserted.

This function will insert a specified number of copies of the given data before the location specified by position.

This operation is linear in the number of elements inserted and does not invalidate iterators and references.

Definition at line 1123 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> void std::list< _Tp, _Alloc >::insert (iterator__position, _InputIterator__first, _InputIterator__last) [inline]

Inserts a range into the list.

Parameters:
    __position An iterator into the list.
    __first An input iterator.
    __last An input iterator.

This function will insert copies of the data in the range [first,last) into the list before the location specified by position.

This operation is linear in the number of elements inserted and does not invalidate iterators and references.

Definition at line 1149 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> size_type std::list< _Tp, _Alloc >::max_size () const [inline], [noexcept]
Returns the size() of the largest possible list.

Definition at line 878 of file stl_list.h.

  template<typename _Tp , typename _Alloc > void list::merge (list< _Tp, _Alloc > &&__x)

Merge sorted lists.

Parameters:
    __x Sorted list to merge.

Assumes that both __x and this list are sorted according to operator<(). Merges elements of __x into this list in sorted order, leaving __x empty when complete. Elements in this list precede elements in __x that are equal.

Definition at line 288 of file list.tcc.

References std::begin(), std::list< _Tp, _Alloc >::begin(), std::end(), and std::list< _Tp, _Alloc >::end().

Referenced by std::list< _Tp, _Alloc >::sort().

  template<typename _Tp , typename _Alloc > template<typename _StrictWeakOrdering > void list::merge (list< _Tp, _Alloc > &&__x, _StrictWeakOrdering__comp)

Merge sorted lists according to comparison function.

Template Parameters:
    _StrictWeakOrdering Comparison function defining sort order.

Parameters:
    __x Sorted list to merge.
    __comp Comparison functor.

Assumes that both __x and this list are sorted according to StrictWeakOrdering. Merges elements of __x into this list in sorted order, leaving __x empty when complete. Elements in this list precede elements in __x that are equivalent according to StrictWeakOrdering().

Definition at line 322 of file list.tcc.

References std::begin(), std::list< _Tp, _Alloc >::begin(), std::end(), and std::list< _Tp, _Alloc >::end().

  template<typename _Tp , typename _Alloc > list< _Tp, _Alloc > & list::operator= (const list< _Tp, _Alloc > &__x)

List assignment operator. No explicit dtor needed as the _Base dtor takes care of things. The _Base dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Parameters:
    __x A list of identical element and allocator types.

All the elements of __x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 185 of file list.tcc.

References std::begin(), std::list< _Tp, _Alloc >::begin(), std::end(), and std::list< _Tp, _Alloc >::end().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> list& std::list< _Tp, _Alloc >::operator= (list< _Tp, _Alloc > &&__x) [inline]

List move assignment operator.

Parameters:
    __x A list of identical element and allocator types.

The contents of __x are moved into this list (without copying). __x is a valid, but unspecified list

Definition at line 667 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> list& std::list< _Tp, _Alloc >::operator= (initializer_list< value_type >__l) [inline]

List initializer list assignment operator.

Parameters:
    __l An initializer_list of value_type.

Replace the contents of the list with copies of the elements in the initializer_list __l. This is linear in l.size().

Definition at line 684 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::pop_back () [inline]

Removes last element. This is a typical stack operation. It shrinks the list by one. Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed.

Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.

Definition at line 1041 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::pop_front () [inline]

Removes first element. This is a typical stack operation. It shrinks the list by one. Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called.

Definition at line 1001 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::push_back (const value_type &__x) [inline]

Add data to the end of the list.

Parameters:
    __x Data to be added.

This is a typical stack operation. The function creates an element at the end of the list and assigns the given data to it. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 1015 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::push_front (const value_type &__x) [inline]

Add data to the front of the list.

Parameters:
    __x Data to be added.

This is a typical stack operation. The function creates an element at the front of the list and assigns the given data to it. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 974 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reverse_iterator std::list< _Tp, _Alloc >::rbegin () [inline], [noexcept]
Returns a read/write reverse iterator that points to the last element in the list. Iteration is done in reverse element order.

Definition at line 794 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reverse_iterator std::list< _Tp, _Alloc >::rbegin () const [inline], [noexcept]
Returns a read-only (constant) reverse iterator that points to the last element in the list. Iteration is done in reverse element order.

Definition at line 803 of file stl_list.h.

  template<typename _Tp, typename _Alloc > void list::remove (const _Tp &__value)

Remove all elements equal to value.

Parameters:
    __value The value to remove.

Removes every element in the list equal to value. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 239 of file list.tcc.

References std::__addressof(), std::begin(), and std::end().

  template<typename _Tp , typename _Alloc > template<typename _Predicate > void list::remove_if (_Predicate__pred)

Remove all elements satisfying a predicate.

Template Parameters:
    _Predicate Unary predicate function or object.

Removes every element in the list for which the predicate returns true. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 392 of file list.tcc.

References std::begin(), and std::end().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reverse_iterator std::list< _Tp, _Alloc >::rend () [inline], [noexcept]
Returns a read/write reverse iterator that points to one before the first element in the list. Iteration is done in reverse element order.

Definition at line 812 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reverse_iterator std::list< _Tp, _Alloc >::rend () const [inline], [noexcept]
Returns a read-only (constant) reverse iterator that points to one before the first element in the list. Iteration is done in reverse element order.

Definition at line 821 of file stl_list.h.

  template<typename _Tp , typename _Alloc > void list::resize (size_type__new_size)

Resizes the list to the specified number of elements.

Parameters:
    __new_size Number of elements the list should contain.

This function will resize the list to the specified number of elements. If the number is smaller than the list's current size the list is truncated, otherwise default constructed elements are appended.

Definition at line 139 of file list.tcc.

References std::begin(), and std::end().

  template<typename _Tp , typename _Alloc > void list::resize (size_type__new_size, const value_type &__x)

Resizes the list to the specified number of elements.

Parameters:
    __new_size Number of elements the list should contain.
    __x Data with which new elements should be populated.

This function will resize the list to the specified number of elements. If the number is smaller than the list's current size the list is truncated, otherwise the list is extended and new elements are populated with given data.

Definition at line 154 of file list.tcc.

References std::begin(), and std::end().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::reverse () [inline], [noexcept]

Reverse the elements in list. Reverse the order of elements in the list in linear time.

Definition at line 1449 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> size_type std::list< _Tp, _Alloc >::size () const [inline], [noexcept]
Returns the number of elements in the list.

Definition at line 873 of file stl_list.h.

  template<typename _Tp , typename _Alloc > void list::sort ()

Sort the elements. Sorts the elements of this list in NlogN time. Equivalent elements remain in list order.

Definition at line 354 of file list.tcc.

References std::begin(), std::list< _Tp, _Alloc >::begin(), std::list< _Tp, _Alloc >::empty(), std::list< _Tp, _Alloc >::merge(), std::list< _Tp, _Alloc >::splice(), and std::list< _Tp, _Alloc >::swap().

  template<typename _Tp , typename _Alloc > template<typename _StrictWeakOrdering > void list::sort (_StrictWeakOrdering__comp)

Sort the elements according to comparison function. Sorts the elements of this list in NlogN time. Equivalent elements remain in list order.

Definition at line 431 of file list.tcc.

References std::begin(), std::list< _Tp, _Alloc >::begin(), std::list< _Tp, _Alloc >::empty(), std::list< _Tp, _Alloc >::merge(), std::list< _Tp, _Alloc >::splice(), and std::list< _Tp, _Alloc >::swap().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::splice (iterator__position, list< _Tp, _Alloc > &&__x) [inline]

Insert contents of another list.

Parameters:
    __position Iterator referencing the element to insert before.
    __x Source list.

The elements of __x are inserted in constant time in front of the element referenced by __position. __x becomes an empty list.

Requires this != __x.

Definition at line 1248 of file stl_list.h.

Referenced by std::list< __inp, __rebind_inp >::insert(), and std::list< _Tp, _Alloc >::sort().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::splice (iterator__position, list< _Tp, _Alloc > &&__x, iterator__i) [inline]

Insert element from another list.

Parameters:
    __position Iterator referencing the element to insert before.
    __x Source list.
    __i Iterator referencing the element to move.

Removes the element in list __x referenced by __i and inserts it into the current list before __position.

Definition at line 1278 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::splice (iterator__position, list< _Tp, _Alloc > &&__x, iterator__first, iterator__last) [inline]

Insert range from another list.

Parameters:
    __position Iterator referencing the element to insert before.
    __x Source list.
    __first Iterator referencing the start of range in x.
    __last Iterator referencing the end of range in x.

Removes elements in the range [__first,__last) and inserts them before __position in constant time.

Undefined if __position is in [__first,__last).

Definition at line 1314 of file stl_list.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::list< _Tp, _Alloc >::swap (list< _Tp, _Alloc > &__x) [inline]

Swaps data with another list.

Parameters:
    __x A list of the same element and allocator types.

This exchanges the elements between two lists in constant time. Note that the global std::swap() function is specialized such that std::swap(l1,l2) will feed to this function.

Definition at line 1210 of file stl_list.h.

Referenced by std::list< __inp, __rebind_inp >::operator=(), std::list< _Tp, _Alloc >::sort(), and std::swap().

  template<typename _Tp , typename _Alloc > void list::unique ()

Remove consecutive duplicate elements. For each consecutive set of elements with the same value, remove all but the first one. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 267 of file list.tcc.

References std::begin(), and std::end().

  template<typename _Tp , typename _Alloc > template<typename _BinaryPredicate > void list::unique (_BinaryPredicate__binary_pred)

Remove consecutive elements satisfying a predicate.

Template Parameters:
    _BinaryPredicate Binary predicate function or object.

For each consecutive set of elements [first,last) that satisfy predicate(first,i) where i is an iterator in [first,last), remove all but the first one. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 410 of file list.tcc.

References std::begin(), and std::end().

Author

Generated automatically by Doxygen for libstdc++ from the source code.